searchNodes=[{"ref":"Instream.Connection.html","title":"Instream.Connection","type":"behaviour","doc":"Connection (pool) definition. All database connections will be made using a user-defined extension of this module. Example Module defmodule MyConnection do use Instream.Connection, otp_app: :my_application end Example Configuration config :my_application, MyConnection, auth: [ method: :basic, username: &quot;root&quot;, password: &quot;root&quot; ] host: &quot;influxdb.example.com&quot;, http_opts: [ insecure: true, proxy: &quot;http://company.proxy&quot; ], loggers: [{ LogModule, :log_fun, [ :additional, :args ] }], pool: [ max_overflow: 10, size: 5 ], port: 8086, scheme: &quot;http&quot;"},{"ref":"Instream.Connection.html#c:__log__/1","title":"Instream.Connection.__log__/1","type":"callback","doc":"Sends a log entry to all configured loggers."},{"ref":"Instream.Connection.html#c:child_spec/1","title":"Instream.Connection.child_spec/1","type":"callback","doc":"Returns a supervisable connection child_spec."},{"ref":"Instream.Connection.html#c:config/1","title":"Instream.Connection.config/1","type":"callback","doc":"Returns the connection configuration."},{"ref":"Instream.Connection.html#c:execute/2","title":"Instream.Connection.execute/2","type":"callback","doc":"Executes a query. Passing [async: true] in the options always returns :ok. The command will be executed asynchronously."},{"ref":"Instream.Connection.html#c:ping/2","title":"Instream.Connection.ping/2","type":"callback","doc":"Pings a server. By default the first server in your connection configuration will be pinged. The server passed does not necessarily need to belong to your connection. Only the connection details (scheme, port, ...) will be used to determine the exact url to send the ping request to."},{"ref":"Instream.Connection.html#c:query/2","title":"Instream.Connection.query/2","type":"callback","doc":"Executes a reading query. Options: method: whether to use a &quot;GET&quot; or &quot;POST&quot; request (as atom) precision: see Instream.Encoder.Precision for available values See Instream.Connection.execute/2 for additional generic options."},{"ref":"Instream.Connection.html#c:status/1","title":"Instream.Connection.status/1","type":"callback","doc":"Checks the status of a connection."},{"ref":"Instream.Connection.html#c:version/2","title":"Instream.Connection.version/2","type":"callback","doc":"Determines the version of an InfluxDB host. The version will be retrieved using a :ping query and extract the returned X-Influxdb-Version header. If the header is missing the version will be returned as &quot;unknown&quot;."},{"ref":"Instream.Connection.html#c:write/2","title":"Instream.Connection.write/2","type":"callback","doc":"Executes a writing query. See Instream.Connection.execute/2 for additional generic options."},{"ref":"Instream.Connection.html#t:log_entry/0","title":"Instream.Connection.log_entry/0","type":"type","doc":""},{"ref":"Instream.Connection.html#t:query_type/0","title":"Instream.Connection.query_type/0","type":"type","doc":""},{"ref":"Instream.Connection.Config.html","title":"Instream.Connection.Config","type":"module","doc":"Configuration helper module."},{"ref":"Instream.Connection.Config.html#compile_time/3","title":"Instream.Connection.Config.compile_time/3","type":"function","doc":"Retrieves the compile time part of the connection configuration."},{"ref":"Instream.Connection.Config.html#runtime/4","title":"Instream.Connection.Config.runtime/4","type":"function","doc":"Retrieves the runtime connection configuration for conn in otp_app."},{"ref":"Instream.Connection.Supervisor.html","title":"Instream.Connection.Supervisor","type":"module","doc":"Connection Supervisor."},{"ref":"Instream.Connection.Supervisor.html#child_spec/1","title":"Instream.Connection.Supervisor.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Instream.Connection.Supervisor.html#start_link/1","title":"Instream.Connection.Supervisor.start_link/1","type":"function","doc":"Starts the supervisor."},{"ref":"Instream.Database.html","title":"Instream.Database","type":"behaviour","doc":"Defines a database. Usage defmodule MyDatabase use Instream.Database database do name &quot;my_database&quot; end end Metadata The metadata of a database (e.g. the name) can be retrieved using the __meta__/1 method."},{"ref":"Instream.Database.html#c:__meta__/1","title":"Instream.Database.__meta__/1","type":"callback","doc":"Provides metadata access for a database. Available information :name - the name of the database"},{"ref":"Instream.Database.html#database/1","title":"Instream.Database.database/1","type":"macro","doc":"Defines the database."},{"ref":"Instream.Database.html#name/1","title":"Instream.Database.name/1","type":"macro","doc":"Defines the name of the database."},{"ref":"Instream.Database.Validator.html","title":"Instream.Database.Validator","type":"module","doc":"Performs compile time validations of database definitions."},{"ref":"Instream.Database.Validator.html#proper_database?/1","title":"Instream.Database.Validator.proper_database?/1","type":"function","doc":"Checks if all mandatory definitions for a database are available."},{"ref":"Instream.Encoder.InfluxQL.html","title":"Instream.Encoder.InfluxQL","type":"module","doc":"Encoder module for InfluxQL."},{"ref":"Instream.Encoder.InfluxQL.html#encode/1","title":"Instream.Encoder.InfluxQL.encode/1","type":"function","doc":"Converts a query builder struct to InfluxQL."},{"ref":"Instream.Encoder.Line.html","title":"Instream.Encoder.Line","type":"module","doc":"Encoder module for the line protocol. Takes a list of points and returns the data string to be passed to the write endpoint of influxdb."},{"ref":"Instream.Encoder.Line.html#encode/1","title":"Instream.Encoder.Line.encode/1","type":"function","doc":"Creates the write string for a list of data points."},{"ref":"Instream.Encoder.Line.html#t:point_map/0","title":"Instream.Encoder.Line.point_map/0","type":"type","doc":""},{"ref":"Instream.Encoder.Precision.html","title":"Instream.Encoder.Precision","type":"module","doc":"Encoder module for precision values. Converts a MODULE.t type precision atom to its binary counterpart."},{"ref":"Instream.Encoder.Precision.html#encode/1","title":"Instream.Encoder.Precision.encode/1","type":"function","doc":"Converts a precision atom to its binary identifier."},{"ref":"Instream.Encoder.Precision.html#t:t/0","title":"Instream.Encoder.Precision.t/0","type":"type","doc":""},{"ref":"Instream.Encoder.Precision.html#t:t_deprecated/0","title":"Instream.Encoder.Precision.t_deprecated/0","type":"type","doc":""},{"ref":"Instream.Log.DefaultLogger.html","title":"Instream.Log.DefaultLogger","type":"module","doc":"Default logger for all entries."},{"ref":"Instream.Log.DefaultLogger.html#log/1","title":"Instream.Log.DefaultLogger.log/1","type":"function","doc":"Logs a request."},{"ref":"Instream.Log.Metadata.html","title":"Instream.Log.Metadata","type":"module","doc":"Metadata common to all log entries."},{"ref":"Instream.Log.Metadata.html#t:t/0","title":"Instream.Log.Metadata.t/0","type":"type","doc":""},{"ref":"Instream.Log.PingEntry.html","title":"Instream.Log.PingEntry","type":"module","doc":"Log entry definition for ping requests."},{"ref":"Instream.Log.PingEntry.html#t:t/0","title":"Instream.Log.PingEntry.t/0","type":"type","doc":""},{"ref":"Instream.Log.QueryEntry.html","title":"Instream.Log.QueryEntry","type":"module","doc":"Log entry definition for query requests."},{"ref":"Instream.Log.QueryEntry.html#t:t/0","title":"Instream.Log.QueryEntry.t/0","type":"type","doc":""},{"ref":"Instream.Log.StatusEntry.html","title":"Instream.Log.StatusEntry","type":"module","doc":"Log entry definition for status requests."},{"ref":"Instream.Log.StatusEntry.html#t:t/0","title":"Instream.Log.StatusEntry.t/0","type":"type","doc":""},{"ref":"Instream.Log.WriteEntry.html","title":"Instream.Log.WriteEntry","type":"module","doc":"Log entry definition for write requests."},{"ref":"Instream.Log.WriteEntry.html#t:t/0","title":"Instream.Log.WriteEntry.t/0","type":"type","doc":""},{"ref":"Instream.Query.html","title":"Instream.Query","type":"module","doc":"Query struct."},{"ref":"Instream.Query.html#t:payload_type/0","title":"Instream.Query.payload_type/0","type":"type","doc":""},{"ref":"Instream.Query.html#t:query_method/0","title":"Instream.Query.query_method/0","type":"type","doc":""},{"ref":"Instream.Query.html#t:query_type/0","title":"Instream.Query.query_type/0","type":"type","doc":""},{"ref":"Instream.Query.html#t:t/0","title":"Instream.Query.t/0","type":"type","doc":""},{"ref":"Instream.Query.Headers.html","title":"Instream.Query.Headers","type":"module","doc":"Header Utility."},{"ref":"Instream.Query.Headers.html#assemble/2","title":"Instream.Query.Headers.assemble/2","type":"function","doc":"Assembles the headers for a query."},{"ref":"Instream.Query.Headers.html#assemble_auth/1","title":"Instream.Query.Headers.assemble_auth/1","type":"function","doc":"Assembles headers for basic authentication. Will return an empty list if query authentication is configured. Will return an empty list if either username of password is missing. Usage iex&gt; assemble_auth([ method: :query ]) [] iex&gt; assemble_auth([ username: &quot;user&quot; ]) [] iex&gt; assemble_auth([ password: &quot;pass&quot; ]) [] iex&gt; assemble_auth([ username: &quot;user&quot;, password: &quot;pass&quot; ]) [{&quot;Authorization&quot;, &quot;Basic dXNlcjpwYXNz&quot;}]"},{"ref":"Instream.Query.Headers.html#assemble_encoding/1","title":"Instream.Query.Headers.assemble_encoding/1","type":"function","doc":"Assembles headers for response encoding. Usage iex&gt; assemble_encoding(nil) [] # not handled here... iex&gt; assemble_encoding(:raw) [] iex&gt; assemble_encoding(:csv) [{&quot;Accept&quot;, &quot;application/csv&quot;}] iex&gt; assemble_encoding(:json) [{&quot;Accept&quot;, &quot;application/json&quot;}]"},{"ref":"Instream.Query.Headers.html#assemble_language/1","title":"Instream.Query.Headers.assemble_language/1","type":"function","doc":"Assembles headers required for query language selection. Usage iex&gt; assemble_language(nil) [] iex&gt; assemble_language(:flux) [{&quot;Accept&quot;, &quot;application/csv&quot;}, {&quot;Content-Type&quot;, &quot;application/vnd.flux&quot;}]"},{"ref":"Instream.Query.URL.html","title":"Instream.Query.URL","type":"module","doc":"URL Utility."},{"ref":"Instream.Query.URL.html#append_auth/2","title":"Instream.Query.URL.append_auth/2","type":"function","doc":"Appends authentication credentials to a URL."},{"ref":"Instream.Query.URL.html#append_database/2","title":"Instream.Query.URL.append_database/2","type":"function","doc":"Appends a database to a URL."},{"ref":"Instream.Query.URL.html#append_epoch/2","title":"Instream.Query.URL.append_epoch/2","type":"function","doc":"Appends an epoch value to a URL. The allowed values are identical to the precision parameters of write queries."},{"ref":"Instream.Query.URL.html#append_precision/2","title":"Instream.Query.URL.append_precision/2","type":"function","doc":"Appends a precision value to a URL."},{"ref":"Instream.Query.URL.html#append_query/2","title":"Instream.Query.URL.append_query/2","type":"function","doc":"Appends a query to a URL."},{"ref":"Instream.Query.URL.html#append_retention_policy/2","title":"Instream.Query.URL.append_retention_policy/2","type":"function","doc":"Appends a retention policy to a URL."},{"ref":"Instream.Query.URL.html#ping/2","title":"Instream.Query.URL.ping/2","type":"function","doc":"Returns the proper URL for a :ping request."},{"ref":"Instream.Query.URL.html#query/2","title":"Instream.Query.URL.query/2","type":"function","doc":"Returns the proper URL for a :query request."},{"ref":"Instream.Query.URL.html#status/2","title":"Instream.Query.URL.status/2","type":"function","doc":"Returns the proper URL for a :status request."},{"ref":"Instream.Query.URL.html#write/1","title":"Instream.Query.URL.write/1","type":"function","doc":"Returns the proper URL for a :write request."},{"ref":"Instream.Series.html","title":"Instream.Series","type":"behaviour","doc":"Defines a series. Usage defmodule MySeries do use Instream.Series series do database &quot;my_database_optional&quot; measurement &quot;cpu_load&quot; tag :host, default: &quot;www&quot; tag :core field :value, default: 100 field :value_desc end end Metadata The metadata of a series (e.g. the measurement) can be retrieved using the __meta__/1 method. Struct Every series will be registered as a struct. Following the above usage example you will get the following struct: %MySeries{ fields: %MySeries.Fields{ value: 100, value_desc: nil }, tags: %MySeries.Tags{ host: &quot;www&quot;, core: nil }, timestamp: nil } :timestamp is expected to be a unix nanosecond timestamp."},{"ref":"Instream.Series.html#c:__meta__/1","title":"Instream.Series.__meta__/1","type":"callback","doc":"Provides metadata access for a series. Available information :database - the database where the series is stored (optional) :fields - the fields in the series :measurement - the measurement of the series :tags - the available tags defining the series"},{"ref":"Instream.Series.html#database/1","title":"Instream.Series.database/1","type":"macro","doc":"Defines the database for the series."},{"ref":"Instream.Series.html#field/2","title":"Instream.Series.field/2","type":"macro","doc":"Defines a field in the series."},{"ref":"Instream.Series.html#c:from_map/1","title":"Instream.Series.from_map/1","type":"callback","doc":"Creates a series dataset from any given map. Keys not defined in the series are silently dropped."},{"ref":"Instream.Series.html#c:from_result/1","title":"Instream.Series.from_result/1","type":"callback","doc":"Creates a list of series datasets from a query result map. Keys not defined in the series are silently dropped."},{"ref":"Instream.Series.html#measurement/1","title":"Instream.Series.measurement/1","type":"macro","doc":"Defines the measurement of the series."},{"ref":"Instream.Series.html#series/1","title":"Instream.Series.series/1","type":"macro","doc":"Defines the series."},{"ref":"Instream.Series.html#tag/2","title":"Instream.Series.tag/2","type":"macro","doc":"Defines a tag in the series."},{"ref":"Instream.Series.Hydrator.html","title":"Instream.Series.Hydrator","type":"module","doc":"Hydrates series datasets."},{"ref":"Instream.Series.Hydrator.html#from_map/2","title":"Instream.Series.Hydrator.from_map/2","type":"function","doc":"Converts a plain map into a series definition struct. Keys not defined in the series are silently dropped."},{"ref":"Instream.Series.Hydrator.html#from_result/2","title":"Instream.Series.Hydrator.from_result/2","type":"function","doc":"Converts a query result map into a list of series definition structs. Keys not defined in the series are silently dropped."},{"ref":"Instream.Series.Validator.html","title":"Instream.Series.Validator","type":"module","doc":"Performs compile time validations of series definitions."},{"ref":"Instream.Series.Validator.html#proper_series?/1","title":"Instream.Series.Validator.proper_series?/1","type":"function","doc":"Checks if all mandatory definitions for a series are available."},{"ref":"Instream.Validate.html","title":"Instream.Validate","type":"module","doc":"Validation utility."},{"ref":"Instream.Validate.html#database!/1","title":"Instream.Validate.database!/1","type":"function","doc":"Validates a database name. If the validation succeeds the database name will be returned. Otherwise an ArgumentError will be raised."},{"ref":"Instream.Writer.html","title":"Instream.Writer","type":"behaviour","doc":"Point writer behaviour."},{"ref":"Instream.Writer.html#c:write/3","title":"Instream.Writer.write/3","type":"callback","doc":"Writes a point. The worker_state parameter contains the state of the worker requesting the write operation. Please refer to the Instream.Pool.Worker module to see which parameters are available."},{"ref":"Instream.Writer.Line.html","title":"Instream.Writer.Line","type":"module","doc":"Point writer for the line protocol."},{"ref":"Instream.Writer.Line.html#write/3","title":"Instream.Writer.Line.write/3","type":"function","doc":"Writes a point. The worker_state parameter contains the state of the worker requesting the write operation. Please refer to the Instream.Pool.Worker module to see which parameters are available. Callback implementation for Instream.Writer.write/3."},{"ref":"Instream.Writer.UDP.html","title":"Instream.Writer.UDP","type":"module","doc":"Point writer for the line protocol using UDP."},{"ref":"Instream.Writer.UDP.html#write/3","title":"Instream.Writer.UDP.write/3","type":"function","doc":"Writes a point. The worker_state parameter contains the state of the worker requesting the write operation. Please refer to the Instream.Pool.Worker module to see which parameters are available. Callback implementation for Instream.Writer.write/3."},{"ref":"changelog.html","title":"Changelog","type":"extras","doc":"Changelog"},{"ref":"changelog.html#v0-20-0-2019-04-19","title":"Changelog - v0.20.0 (2019-04-19)","type":"extras","doc":"Enhancements Queries can be sent as Flux language queries to InfluxDB using [query_language: :flux] in the connection or query options Soft deprecations (no warnings) The query builder has been removed from documentation and will be eventually removed completely. This will be done because of the current limitations of the builder implementation and the InfluxDB move from InfluxQL to Flux as the query language of choice Deprecations Accessing the system environment by configuring {:system, var} or {:system, var, default} will now result in a Logger.info/1 message and will stop working in a future release Implementing use Instream.Writer has been deprecated in favor of the more explicit @behaviour Instream.Writer. Old implementations will trigger a compile time warning until the old macro is removed The already (soft) deprecated time units with plural names (e.g. :seconds) will now issue Logger.info/1 messages when used Backwards incompatible changes Support for the InfluxDB versions earlier than 1.4.x is no longer guaranteed"},{"ref":"changelog.html#v0-19-0-2019-01-24","title":"Changelog - v0.19.0 (2019-01-24)","type":"extras","doc":"Enhancements Connections can be declared with compile time configuration defaults that are later overwritten by the application environment The library used for JSON decoding can be changed by using the :json_decoder configuration Soft deprecations (no warnings) All &quot;administrative query modules&quot; have been removed from the documentation. They will eventually be removed completely after a proper deprecation phase Support for {:system, &quot;ENV_VARIABLE&quot;} configuration has been removed from the documentation. It will eventually be removed completely after a proper deprecation phase Backwards incompatible changes Default configuration has been extended with host: &quot;localhost&quot; Minimum required elixir version is now ~&gt; 1.5 Missing application configuration will no longer raise during compilation Public access to the internal pool module name has been removed"},{"ref":"changelog.html#v0-18-0-2018-08-11","title":"Changelog - v0.18.0 (2018-08-11)","type":"extras","doc":"Enhancements Configuration can be done on connection (re-) start by setting a {mod, fun} tuple for the config key :init. This method will be called with the connection module name as the first (and only) parameter and is expected to return :ok Experimental support to convert plain maps or query results into series structs has been added Passwords are automatically redacted from logged queries when using the default logger Supporting rules for the elixir formatter are available Bug fixes Special characters in url parameter values (like &amp; or ? in a query) are now properly escaped (#43) Backwards incompatible changes Quoting of identifiers/values has been extracted to the package influxql (hex)"},{"ref":"changelog.html#v0-17-1-2017-12-16","title":"Changelog - v0.17.1 (2017-12-16)","type":"extras","doc":"Enhancements Support for Elixir 1.5 style child_spec has been added (#39)"},{"ref":"changelog.html#v0-17-0-2017-12-10","title":"Changelog - v0.17.0 (2017-12-10)","type":"extras","doc":"Backwards incompatible changes Minimum required elixir version is now ~&gt; 1.3"},{"ref":"changelog.html#v0-16-0-2017-09-25","title":"Changelog - v0.16.0 (2017-09-25)","type":"extras","doc":"Enhancements Queries can be executed with an additional option :pool_timeout used to wait for an available worker process. This option is independent of other configured/passed timeouts System environment configuration can set an optional default value to be used if the environment variable is unset Bug fixes All queries now use a GenServer.call/3 timeout of :infinity. This allows raising the timeouts for a call above the default of 5_000 (#38)"},{"ref":"changelog.html#v0-15-0-2017-03-16","title":"Changelog - v0.15.0 (2017-03-16)","type":"extras","doc":"Enhancements Every connection method (like read or write) can set per-call http_opts passed on to the hackney client Querying for data can now return an {:error, term} style tuple if the communication with the server failed. For example {:error, :nxdomain} if the host that is queried cannot be resolved by hackney (#33) The line writer now accepts a retention policy used for writing (#34) The line writer will now return an {:error, term} style tuple if a problem occurs. For example {:error, :nxdomain} if the host that should receive data cannot be resolved by hackney (#33) Timeouts occurring when executing a query are now returned as {:error, :timeout} instead of raising (#33) Backwards incompatible changes Series definitions raise upon compilation if the contain a tag and a field with the same name. This is done to prevent the InfluxDB behavior of adding _1 to such fields when storing them"},{"ref":"changelog.html#v0-14-0-2016-12-18","title":"Changelog - v0.14.0 (2016-12-18)","type":"extras","doc":"Enhancements Connections can be configured with a default database used when no value is found in method call or series definition Fields and tags with the name :time will raise after compilation. They are unqueryable and will be dropped by InfluxDB v1.1.0 when trying to write them. Queries can return CSV formatted responses from the server when running InfluxDB &gt;= 1.1.0 Series definitions are now automatically associated with typespecs Backwards incompatible changes Minimum required elixir version is now ~&gt; 1.2 Minimum required erlang version is now ~&gt; 18.0 Query builder support for IF NOT EXISTS has been removed Series definitions now require to contain at least one field Soft deprecations (no warnings) The plural names for precision units have been soft deprecated to be in line with the similar new naming in Erlang 19.1 and the upcoming Elixir 1.4.0. The old types will continue to work but their usage is discouraged. They will be completely deprecated in an upcoming release."},{"ref":"changelog.html#v0-13-0-2016-09-11","title":"Changelog - v0.13.0 (2016-09-11)","type":"extras","doc":"Enhancements Configuration has been split into &quot;compile time&quot; and &quot;runtime&quot; parts. This readds the possibility to change configuration values without recompiling the connection modules (#22) Configuration values can be fetched from the system environment using {:system, ENV_VAR} Timeouts for queries (individual and connection wide) can be configured (#21) Query builder supports LIMIT and OFFSET for queries (#19) Writing a series struct with one or more empty tags will now properly construct an entry without these tags present Soft deprecations (no warnings) The precision units :micro_seconds, :milli_seconds and :nano_seconds have been renamed to :microseconds, :milliseconds and :nanoseconds to matches the upcoming System.time_unit definition of Elixir 1.3.0. Old variables will continue to work but are highly discouraged and will be completely deprecated in an upcoming release. Deprecations Defining a series without fields is deprecated and will raise in a future version Backwards incompatible changes Configuring a connection with multiple hosts is no longer supported The otp app of a connection is no longer returned when calling MyConnection.config/0,1. It is now only available by specifically requesting it via MyConnection.config([:otp_app]) Writer modules now get a map passed with the connection module registered at key :module and (if configured) a udp socket for writing at :udp_socket The Cluster namespace of queries has been removed"},{"ref":"changelog.html#v0-12-0-2016-05-13","title":"Changelog - v0.12.0 (2016-05-13)","type":"extras","doc":"Enhancements Namespace of administrational convenience modules has been changed from Cluster to the better matching Admin Deprecations Configuring a connection with multiple hosts has been deprecated. Instead of multiple :hosts only a single :host is now expected The Cluster namespace of queries has been changed to Admin. For some backwards compatibility the old modules are delegated to the new ones until removed in the next release Backwards incompatible changes Atoms for defining a series&#39; database are no longer supported Atoms for defining a series&#39; measurement are no longer supported Support for the JSON protocol has been removed matching its removal in InfluxDB v0.12.0 Support for the SHOW SERVERS statement has been removed matching its removal in InfluxDB v0.13.0"},{"ref":"changelog.html#v0-11-0-2016-04-14","title":"Changelog - v0.11.0 (2016-04-14)","type":"extras","doc":"Enhancements Hackney options can be configured (#17) Line writer now prefers a database passed via arguments over the one passed in the datapoint payload Logging for requests is available Pings can be send to specific servers Status requests can be send to a cluster Bug fixes Series are now compiled with full environment information preventing &quot;/path/to/lib/nofile&quot; to be compiled as the source of MySeries.Fields or MySeries.Tags Backwards incompatible changes Runtime connection configuration reading has been removed in favor of compile time inlining"},{"ref":"changelog.html#v0-10-0-2016-02-27","title":"Changelog - v0.10.0 (2016-02-27)","type":"extras","doc":"Enhancements Default precision (:rfc3339) can be explicitly set Query builder can construct CREATE DATABASE statements Query builder can construct CREATE RETENTION POLICY statements Query builder can construct DROP DATABASE statements Query builder can construct DROP RETENTION POLICY statements Query builder can construct SHOW statements Series database definitions allow anything &quot;evaluating to a string&quot; (#14) Series measurement definitions allow anything &quot;evaluating to a string&quot; (#14) Deprecations Atoms for defining a series&#39; database are deprecated Atoms for defining a series&#39; measurement are deprecated Using if_not_exists (CREATE DATABASE) has been deprecated and will be completely removed once InfluxDB removes it Backwards incompatible changes :cluster query type has been removed in favor of regular :read queries Retention policy convenience function has been replaced with a more detailed version"},{"ref":"changelog.html#v0-9-0-2015-12-27","title":"Changelog - v0.9.0 (2015-12-27)","type":"extras","doc":"Enhancements Error messages are returned without leading/trailing whitespace Experimental query builder Incomplete or missing series definitions raise an error during compilation Ping a connection using Instream.Connection.ping/0 Reading queries can be executed directly using Instream.Connection.query/2 Writing query can be executed directly using Insream.Connection.write/2 Deprecations Using Instream.Data.Read or Instream.Data.Write directly is discouraged and will eventually be removed Backwards incompatible changes The measurement of a series is no longer optional The parameter opts for Instream.Data.Read and Instream.Data.Write is no longer optional use-ing Instream.Series without a complete series definition raises during compilation"},{"ref":"changelog.html#v0-8-0-2015-11-18","title":"Changelog - v0.8.0 (2015-11-18)","type":"extras","doc":"Enhancements Batch writing using Line and UDP writers (#10) Fields can be defined with default values Tags can be defined with default values Writing can be done over UDP using Instream.Writer.UDP"},{"ref":"changelog.html#v0-7-0-2015-10-22","title":"Changelog - v0.7.0 (2015-10-22)","type":"extras","doc":"Enhancements Convenience module for &quot;SHOW DIAGNOSTICS&quot; queries Convenience module for &quot;SHOW STATS&quot; queries Precision (= epoch) can be passed to read queries Precision can be passed to write queries Bug fixes Pool configuration (size, overflow) is now properly taken from configuration Deprecations Support of the JSON protocol is deprecated and will be removed once InfluxDB removes it"},{"ref":"changelog.html#v0-6-0-2015-09-27","title":"Changelog - v0.6.0 (2015-09-27)","type":"extras","doc":"Enhancements IF NOT EXISTS can be passed to database creation queries Points can be written with explicit timestamps (#8) Switched default write method to the line protocol Tags are optional when writing with the line protocol Backwards incompatible changes Switched default write method to the line protocol"},{"ref":"changelog.html#v0-5-0-2015-09-05","title":"Changelog - v0.5.0 (2015-09-05)","type":"extras","doc":"Enhancements Convenience module for SHOW SERVERS queries Queries can be executed asynchronously Support for line protocol Backwards incompatible changes Write queries return :ok instead of nil"},{"ref":"changelog.html#v0-4-0-2015-07-25","title":"Changelog - v0.4.0 (2015-07-25)","type":"extras","doc":"Enhancements Allows using header authentication (basic auth) Allows using pre-defined series modules for write queries Provides a way to define series as a module (struct) Backwards incompatible changes Authentication uses headers by default"},{"ref":"changelog.html#v0-3-0-2015-06-19","title":"Changelog - v0.3.0 (2015-06-19)","type":"extras","doc":"Enhancements Allows managing retention policies Dependencies not used in production builds are marked as optional Bug fixes Authentication is passed using query parameters by default Backwards incompatible changes Auth configuration is now expected to be a Keyword.t Queries of type :host are now of type :cluster Remapped Admin namespace to Cluster to match query types"},{"ref":"changelog.html#v0-2-0-2015-04-19","title":"Changelog - v0.2.0 (2015-04-19)","type":"extras","doc":"Enhancements Allows accessing raw query results (undecoded binaries) using Instream.Connection.execute/2 Read queries (binaries) can be executed on a database Write queries (map data) can be executed on a database"},{"ref":"changelog.html#v0-1-0-2015-02-23","title":"Changelog - v0.1.0 (2015-02-23)","type":"extras","doc":"Initial Release"},{"ref":"readme.html","title":"Instream","type":"extras","doc":"Instream InfluxDB driver for Elixir Note: If you are reading this on GitHub then the information in this file may be out of sync with the Hex package. If you are using this library through Hex please refer to the appropriate documentation on HexDocs."},{"ref":"readme.html#influxdb-support","title":"Instream - InfluxDB Support","type":"extras","doc":"Tested InfluxDB versions: 1.4.3 1.5.5 1.6.6 1.7.6 (see .travis.yml to be sure)"},{"ref":"readme.html#setup","title":"Instream - Setup","type":"extras","doc":"Add Instream as a dependency to your mix.exs file: defp deps do [ # ... {:instream, &quot;~&gt; 0.20&quot;}, # ... ] end Testing To run the tests you need to have the http-authentication enabled. Using the statements from the .travis.yml you can generate all necessary users for the tests with their proper privileges. The test suite will automatically exclude tests not working for your current environment. This includes checking the available InfluxDB version and OTP release. If you have not configured your InfluxDB testing instance to provide an UDP endpoint to the &quot;test_database&quot;, you can exclude these tests manually: mix test --exclude udp"},{"ref":"readme.html#usage","title":"Instream - Usage","type":"extras","doc":"Note: Most queries require a database to operate on. The following places will be searched (in order from top to bottom) for a configured database: opts[:database] parameter Series struct (if used) Connection configuration No database used! Connections Defining a connection requires defining a module: defmodule MyApp.MyConnection do use Instream.Connection, otp_app: :my_app end The :otp_app name and the name of the module can be freely chosen but have to be linked to a corresponding configuration entry. This defined connection module needs to be hooked up into your supervision tree: children = [ # ... MyApp.Connection, # ... ] Configuration (static) The most simple way is to use a completely static configuration: config :my_app, MyApp.MyConnection, database: &quot;my_default_database&quot;, host: &quot;localhost&quot;, http_opts: [insecure: true, proxy: &quot;http://company.proxy&quot;], pool: [max_overflow: 10, size: 50], port: 8086, scheme: &quot;http&quot;, writer: Instream.Writer.Line Configuration (dynamic) If you cannot, for whatever reason, use a static application config you can configure an initializer module that will be called every time your connection is started (or restarted) in your supervision tree: config :my_app, MyApp.MyConnection, init: {MyInitModule, :my_init_fun} defmodule MyInitModule do @spec my_init_fun(module) :: :ok def my_init_fun(conn) do config = Keyword.merge( conn.config(), host: &quot;localhost&quot;, port: 64210 ) Application.put_env(:my_app, conn, config) end end When the connection is started the function will be called with the connection module as the first (and only) parameter. This will be done before the connection is available for use. The function is expected to always return :ok. Configuration (inline defaults) For some use cases (e.g. testing) it may be sufficient to define hardcoded configuration defaults outside of your application environment: defmodule MyApp.MyConnection do use Instream.Connection, otp_app: :my_app, config: [ host: &quot;localhost&quot;, port: 8086 ] end These values will be overwritten by and/or merged with the application environment values when the configuration is accessed. Runtime and Compile Time Configuration The full connection configuration is split into two parts, compile time and runtime configuration. Compile time configuration are, as the name implies, used during compilation for the connection module. Currently the only key in this category is :loggers. All other values are runtime configuration values that are directly accessed from the application environment using Application.get_env(connection_otp_app, connection_module) and therefore can be changed without recompilation: old_config = MyConnection.config() new_config = Keyword.put(old_config, :host, &quot;changed.host&quot;) :ok = Application.put_env(:my_otp_app, MyConnection, new_config) Default Connection Values The following values will be used as defaults if no other value is set: config :my_app, MyApp.MyConnection, host: &quot;localhost&quot;, pool: [max_overflow: 10, size: 5], port: 8086, scheme: &quot;http&quot;, writer: Instream.Writer.Line, json_decoder: Poison This also means that per default the connection uses no authentication. HTTP Client Configuration Internally all requests are done using :hackney. The configuration key :http_opts is directly passed to the client process. Parts of it are also used internally by :hackney to control more generic behaviour (request pool to be used and it&#39;s configuration). Please see :hackney.request/5 for a complete list of available options. Setting the :http_opts key when calling a connection method allows usage of per-call options. The options are merged with the connection options and then passed on. JSON Configuration By default the library used for encoding/decoding JSON is :poison. For the time :instream directly depends on it to ensure it is available. If you want to use another library you can switch it: config :my_app, MyConnection, json_decoder: MyJSONLibrary config :my_app, MyConnection, json_decoder: {MyJSONLibrary, :decode_argless} config :my_app, MyConnection, json_decoder: {MyJSONLibrary, :decode_it, [[keys: :atoms]]} If you configure only a module name it will be called as module.decode!(binary). When using a more complete {m, f} or {m, f, a} configuration the data to decode will passed as the first argument with your configured extra arguments following. Authentication To connect to an InfluxDB instance with http authentication enabled you have to configure your credentials: config :my_app, MyApp.MyConnection, auth: [method: :basic, username: &quot;root&quot;, password: &quot;root&quot;] For method you can choose between header authentication (basic auth) using :basic or query parameters using :query. If nothing or an invalid value is given the connection will be made using :basic authentication. Writer Configuration If you are using the regular line protocol writer Instream.Writer.Line you are done without having anything to configure. It is used by default and connects to the port you have configured for connection. To write points over UDP you can adjust your configuration: config :my_app, MyApp.MyConnection, host: &quot;localhost&quot;, port_udp: 8089, writer: Instream.Writer.UDP The connection will then write using UDP and connecting to the port :port_udp. All non-write queries will be send to the regular :port you have configured. Logging All queries are (by default) logged using Logger.debug/1 via the default logging module Instream.Log.DefaultLogger. To customize logging you have to alter the configuration of your connection: config :my_app, MyApp.MyConnection, loggers: [ {FirstLogger, :log_fun, []}, {SecondLogger, :log_fun, [:additional, :args]} ] This configuration replaces the default logging module. Configuration is given as a tuple of {module, function, arguments}. The log entry will be inserted as the first argument of the method call. It will be one of Instream.Log.PingEntry, Instream.Log.QueryEntry, Instream.Log.StatusEntry or Instream.Log.WriteEntry, depending on what type of request should be logged. Please be aware that every logger has to return the entry it received in order to allow combining multiple loggers. In addition to query specific information every entry carries metadata around: :query_time: milliseconds it took to send request and receive the response response_status: status code or 0 if not applicable/available When using the default logger you have to re-configure :logger to be able to get them printed: config :logger, :console, format: &quot;\\n$time $metadata[$level] $levelpad$message\\n&quot;, metadata: [:application, :pid, :query_time, :response_status] To prevent a query from logging you can pass an option to the execute call: MyApp.MyConnection.execute(query, log: false) # also works with convenience methods MyApp.MyConnection.ping(log: false) Ping / Status / Version To validate a connection you can send ping requests to the server: MyApp.MyConnection.ping() The response will be :pong on success or :error on any failure. To ping &quot;a host other than the first in your configuration&quot; you can pass it explicitly: MyApp.MyConnection.ping(&quot;some.host.name&quot;) All values necessary to ping the host (scheme, port, ...) will be taken from the connection used. It does not matter whether the host is configured in that connection or not. To get InfluxDB to verify the status of your server you can send a status call: MyApp.MyConnection.status() MyApp.MyConnection.status(&quot;some.host.name&quot;) If you are interested in the version of InfluxDB your server is reporting you can request it: MyApp.MyConnection.version() MyApp.MyConnection.version(&quot;some.host.name&quot;) If the version if undetectable (no header returned) it will be reported as &quot;unknown&quot;. If the host is unreachable or an error occurred the response will be :error. Queries Every query can be executed asynchronously by passing [async: true] to MyApp.MyConnection.execute(). The result will then always be an immediate :ok without waiting for the query to be actually executed. By default the response of a query will be a map decoded from your server&#39;s JSON response. Alternatively you can pass [result_as: format] to MyApp.MyConnection.execute/2 to change the result format to one of the following: :csv - CSV encoded response :json - JSON encoded response (implicit default) :raw - Raw server format (JSON string) Query Language Selection If not otherwise specified all queries will be sent as InfluxQL. This can be changed to Flux by passing the option [query_language: :flux] to MyApp.MyConnection.execute/2 Data Queries Please see the point &quot;Series Definitions&quot; on how to write data to your InfluxDB database. Reading data: # passing database to execute/1 &quot;SELECT * FROM some_measurement&quot; |&gt; MyApp.MyConnection.query(database: &quot;my_database&quot;) # defining database in the query &quot;SELECT * FROM \\&quot;my_database\\&quot;.\\&quot;default\\&quot;.\\&quot;some_measurement\\&quot;&quot; |&gt; MyApp.MyConnection.query() # passing precision (= epoch) for query results &quot;SELECT * FROM some_measurement&quot; |&gt; MyApp.MyConnection.query(precision: :minutes) POST Queries Some queries require you to switch from the regular read only context (all GET requets) to a write context (all POST requests). When not using the query build you have to pass that information manually to execute/2: &quot;CREATE DATABASE create_in_write_mode&quot; |&gt; MyApp.MyConnection.execute(method: :post) Query Timeout Configuration Using all default values and no specific parameters each query is allowed to take up to 5000 milliseconds (GenServer.call/2 timeout) to complete. That may be too long or not long enough in some cases. To change that timeout you can configure your connection: # lowering timeout to 500 ms config :my_app, MyApp.MyConnection, query_timeout: 500 or pass an individual timeout for a single query: MyApp.MyConnection.execute(query, timeout: 250) A passed or connection wide timeout configuration override any :recv_timeout of your :hackney (HTTP client) configuration. This does not apply to write requests. They are currently only affected by configured :recv_timeout values. Setting a connection timeout enables you to have a different timeout for read and write requests. For the underlying worker pool you can define a separate timeout: config :my_app, MyApp.MyConnection, pool_timeout: 500 This configuration will be used to wait for an available worker to execute a query and defaults to 5_000."},{"ref":"readme.html#series-definitions","title":"Instream - Series Definitions","type":"extras","doc":"If you do not want to define the raw maps for writing data you can pre-define a series for later usage: defmodule MySeries do use Instream.Series series do database &quot;my_database&quot; measurement &quot;my_measurement&quot; tag :bar tag :foo field :value end end Default Values You can include a default value for tags and fields in your series definition: series do measurement &quot;my_measurement&quot; tag :host, default: &quot;www&quot; field :value, default: 100 end These values will be pre-assigned when using the data struct. All fields or tags without a default value will be set to nil. Series Hydration (Experimental) Whenever you want to convert a plain map or a query result into a specific series you can use the builtin hydration methods: # plain map MySeries.from_map(%{ timestamp: 1234567890, some_tag: &quot;hydrate&quot;, some_field: 123 }) # query result &quot;SELECT * FROM \\&quot;my_measurement\\&quot;&quot; |&gt; MyConnection.query() |&gt; MySeries.from_result() The timestamp itself is kept &quot;as is&quot;. There is (at the moment) no automatic conversion done between to ensure a consistent precisions. This should be done beforehand or kept in mind when writing a hydrated point. Writing Series Points You can then use this module to assemble a data point (one at a time) for writing: data = %MySeries{} data = %{data | fields: %{data.fields | value: 17}} data = %{data | tags: %{data.tags | bar: &quot;bar&quot;, foo: &quot;foo&quot;}} And then write one or many at once: MyApp.MyConnection.write(data) # write the point asynchronously MyApp.MyConnection.write(data, async: true) # write to a specific database MyApp.MyConnection.write(data, database: &quot;my_database&quot;) # write multiple points at once MyApp.MyConnection.write([point_1, point_2, point_3]) If you want to pass an explicit timestamp to the database you can use the key :timestamp: data = %MySeries{} data = %{data | timestamp: 1439587926000000000} The timestamp is (by default) expected to be a nanosecond unix timestamp. To use different precision (for all points in this write operation!) you can change this value by modifying your write call: data = %MySeries{} data = %{data | timestamp: 1439587926} MyApp.MyConnection.write(data, async: true, precision: :second) If you want to specify the target retention policy name for the write, you can do so like this (line protocol only!): MyApp.MyConnection.write(data, retention_policy: &quot;two_weeks&quot;) Supported precision types are: :hour :minute :second :millisecond :microsecond :nanosecond Please be aware that the UDP protocol writer does not support custom timestamp precisions. All UDP timestamps are implicitly expected to already be at nanosecond precision. Note: While it is possible to write multiple points a once it is currently not supported to write them to individual databases. The first point written defines the database, other values are silently ignored! Writing Raw Points When not using Series Definitions raw points can be written using a map like this: %{ points: [ %{ database: &quot;my_database&quot;, # Can be omitted, so default is used. measurement: &quot;my_measurement&quot;, fields: %{answer: 42, value: 1}, tags: %{foo: &quot;bar&quot;}, timestamp: 1439587926000000000 # Nanosecond unix timestamp with default precision, can be omitted. }, # more points possible ... ], database: &quot;my_database&quot;, # Can be omitted, so default is used. } |&gt; MyApp.MyConnection.write() The field timestamp can be omitted, so InfluxDB will use the receive time. The field database can be used to write to a custom database. Please be aware that only the database from the first point will be used when writing multiple points."},{"ref":"readme.html#license","title":"Instream - License","type":"extras","doc":"Apache License, Version 2.0"}]